'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _GridListTile = require('@material-ui/core/GridListTile');

var _GridListTile2 = _interopRequireDefault(_GridListTile);

var _GridListTileBar = require('@material-ui/core/GridListTileBar');

var _GridListTileBar2 = _interopRequireDefault(_GridListTileBar);

var _IconButton = require('@material-ui/core/IconButton');

var _IconButton2 = _interopRequireDefault(_IconButton);

var _FileImage = require('./FileImage');

var _FileImage2 = _interopRequireDefault(_FileImage);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function FileGridItem(props) {
    var file = props.file,
        actionIcon = props.actionIcon,
        onFileClick = props.onFileClick,
        onActionClick = props.onActionClick,
        index = props.index,
        rest = _objectWithoutProperties(props, ['file', 'actionIcon', 'onFileClick', 'onActionClick', 'index']);

    var handleActionClick = function handleActionClick() {
        onActionClick && onActionClick(file, index);
    };

    var handleDownload = function handleDownload() {
        onFileClick && onFileClick(file);
    };

    return _react2.default.createElement(
        _GridListTile2.default,
        _extends({}, rest, {
            style: _extends({}, rest.style, {
                width: 'auto',
                border: '1px solid rgba(0, 0, 0, 0.4)',
                padding: 0,
                margin: '2.5px'
            })
        }),
        _react2.default.createElement(_FileImage2.default, {
            src: file.preview ? file.preview : file.link,
            alt: file.name,
            onClick: handleDownload,
            style: {
                height: '100%',
                cursor: 'pointer'
            }
        }),
        _react2.default.createElement(_GridListTileBar2.default, {
            title: file.name,
            subtitle: _react2.default.createElement(
                'span',
                null,
                file.length + ' bytes'
            ),
            actionIcon: _react2.default.createElement(
                _IconButton2.default,
                { onClick: handleActionClick },
                actionIcon
            )
        })
    );
}

FileGridItem.muiName = 'GridListTile';

FileGridItem.defaultProps = {
    style: {}
};

FileGridItem.propTypes = process.env.NODE_ENV !== "production" ? {
    style: _propTypes2.default.object,
    onFileClick: _propTypes2.default.func,
    onActionClick: _propTypes2.default.func,
    actionIcon: _propTypes2.default.node
} : {};

exports.default = FileGridItem;
module.exports = exports['default'];